# -*- coding: utf-8 -*-
"""
Created on Thu May 27 12:01:20 2021

@author: nicov
"""
import numpy as np
import matplotlib.pyplot as plt

#############################################################################################################
#              I - Clustering et algorithme K-Mean   #########################################################
#############################################################################################################

#\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
#------------ 1)  impotation des données ------------------------------
donnees=[]

f=open('finch_beaks_1975.csv')
texte=f.readlines()
f.close()
for i in range(1,len(texte)):
    L=texte[i].rstrip('\n\r')
    L=L.split(',')
    longueur,profondeur=float(L[2]),float(L[3])
    donnees.append([longueur,profondeur])


"""    
# donnees2=[]    
# f=open('finch_beaks_2012.csv')
# texte=f.readlines()
# f.close()
# for i in range(1,len(texte)):
#     L=texte[i].rstrip('\n\r')
#     L=L.split(',')
#     _ ,longueur,profondeur=L[1],float(L[2]),float(L[3])
#     donnees2.append([longueur,profondeur])



"""


#\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
#-------------------2) Clustering scikit learn -----------------------------------
#                     Premier essai - K choisi arbitrairement

# from sklearn.cluster import KMeans

# KM=KMeans(n_clusters=4, random_state=170) #instancie un objet informatique implémentant la méthode K-Mean
# labels_predits = KM.fit_predict(donnees)  #Utilise l'objet K-Mean pour la détermination des clusters
#                                           #dans les données contenues dans la variable donnees



#\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
#--------------------- 3)  nombre optimal de clusters -------------------------------------

from sklearn.cluster import KMeans
import matplotlib.pyplot as plt

K=2 # à enlever******************************************************************
# KM=KMeans(n_clusters=K, random_state=170)
# labels_predits = KM.fit_predict(donnees)
# Variance=KM.inertia_
#
# #corrigé !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
# K=[1,2,3,4,5,6,9,12]
# L_variance=[]
# for i in range(len(K)):
#     KM=KMeans(n_clusters=K[i], random_state=170)
#     labels_predits = KM.fit_predict(donnees)
#     Variance=KM.inertia_
#     L_variance.append(Variance)
#
# fig, ax = plt.subplots()
# ax.set_xlabel('Nombre K de centroïdes')
# ax.set_ylabel('variance')
# ax.plot(K,L_variance)


# #\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
# #------------------------------- 4)  Affichage des clusters ----------------------------------

# from sklearn.cluster import KMeans
# import matplotlib.pyplot as plt

# K= .... à compléter !!!
# KM=KMeans(n_clusters=K, random_state=170)
# labels_predits = KM.fit_predict(donnees)

# #affichage des nuages de points colorés en fonction du label prédit
# import matplotlib.pyplot as plt

# Donnees_par_classe=[]
# marqueurs=['.','*','o','v','^','d','+']
# fig, ax = plt.subplots()

# L_type_de_classes=np.unique(labels_predits)
# nb_classes=len(L_type_de_classes)
# for classe in L_type_de_classes:
#     X=[]
#     Y=[]
#     for i in range(len(donnees)):
#         if classe ==labels_predits[i]:
#             X.append(donnees[i][0])
#             Y.append(donnees[i][1])
#     Donnees_par_classe.append([X,Y])
#     ax.plot(X,Y,marqueurs[classe],label='classe '+str(classe))

# ax.set_xlabel('Longueur du bec')
# ax.set_ylabel('Profondeur du bec')
# ax.legend()



#\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
#--------------------- 5)  Validation du clustering ------------------------------------------

K=2  # à enlever, remplacer 2 par "à compléter******************************************************************
KM=KMeans(n_clusters=2, random_state=170)
labels_predits = KM.fit_predict(donnees)
Variance=KM.inertia_

labels=[]

f=open('finch_beaks_1975.csv')
texte=f.readlines()
f.close()
for i in range(1,len(texte)):
    L=texte[i].rstrip('\n\r')
    L=L.split(',')
    espece=L[1]
    if espece=='fortis':
        label=0
    else:
        label=1
    labels.append(label)
    
# #corrigé !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
s=0
for i in range(len(labels)):
    if labels[i]==labels_predits[i]:
        s=s+1
taux_d_erreur=(len(labels)-s)/float(len(labels))

#############################################################################################################
#              II - Classification et algorithme KNN              ###########################################
#############################################################################################################

#////////////////////////////////////////////////////////////////////////////////////////////////////////////
#--------------------   1)  Séparation des données     ---------------------------------------------------------

from sklearn import model_selection
(donnees_entrainement, donnees_test, labels_entrainement, labels_test) = model_selection.train_test_split(donnees, labels, test_size=0.3, random_state=12, stratify=labels)


#////////////////////////////////////////////////////////////////////////////////////////////////////////////
#--------------------   2)  KNN avec scikit learn     ---------------------------------------------------------

from sklearn import neighbors
objetKNN = neighbors.KNeighborsClassifier(n_neighbors=20) #crée un objet informatique implémentant 
                                                         #l'algorithme KNN
objetKNN.fit(donnees_entrainement, labels_entrainement)  
labels_predits = objetKNN.predict(donnees_test)         #Applique l'algorithme KNN pour la classification 
                                                         # des données test



#////////////////////////////////////////////////////////////////////////////////////////////////////////////
#--------------------   3)	Validation par matrice de confusion     ---------------------------------------------------------

from sklearn.metrics import confusion_matrix
Matrice_de_confusion = confusion_matrix(labels_test, labels_predits)



